diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
index 2175f4d93..7cdf01baa 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
@@ -9,8 +9,8 @@ import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.Achievements;
@@ -119,9 +119,9 @@ public class RecipePageTrommel
     }
 
     @Override
-    protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    protected void renderForeground(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         if(recipes.isEmpty()){
-            drawStringCenteredNoShadow(fr, I18n.getInstance().translateKey("guidebook.section.search.error.no_recipes") ,x+width/2,y+height/2,0xFF808080);
+            drawStringCenteredNoShadow(sr, I18n.getInstance().translateKey("guidebook.section.search.error.no_recipes") ,x+width/2,y+height/2,0xFF808080);
         }
         SlotGuidebook mouseOverSlot = null;
         for (SlotGuidebook slot : slots) {
@@ -174,8 +174,8 @@ public class RecipePageTrommel
     }
 
     @Override
-    public void render(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
-        super.render(re, fr, x, y, mouseX, mouseY, partialTicks);
+    public void render(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+        super.render(re, sr, x, y, mouseX, mouseY, partialTicks);
 
     }
 
@@ -191,8 +191,8 @@ public class RecipePageTrommel
     }
 
     @Override
-    protected void renderOverlay(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
-        super.renderOverlay(re, fr, x, y, mouseX, mouseY, partialTicks);
+    protected void renderOverlay(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+        super.renderOverlay(re, sr, x, y, mouseX, mouseY, partialTicks);
         SlotGuidebook mouseOverSlot = null;
         for (SlotGuidebook slot : slots) {
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 4a308f6da..859aa3078 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -16,20 +16,20 @@ import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.HeldItemTooltipElement;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.hud.component.HudComponent;
 import net.minecraft.client.gui.hud.component.HudComponents;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.dynamictexture.DynamicTexture;
-import net.minecraft.client.render.entity.EntityRendererItem;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.terrain.RenderList;
 import net.minecraft.client.render.terrain.RenderRegion;
@@ -61,11 +61,11 @@ import org.slf4j.Logger;
 public class HudIngame extends Gui
 {
     public static final float DEBUG_SCALE = 1f;
+    public static final int MAX_CHAT_WIDTH = 320;
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final Direction[] directions = new Direction[]{Direction.NORTH, Direction.EAST, Direction.SOUTH, Direction.WEST};
 
-    public static EntityRendererItem itemRenderer = new EntityRendererItem();
-    private final List<ChatLine> chatMessageList = new ArrayList<>();
+    private final @NotNull List<@NotNull ChatLine> chatMessageList = new ArrayList<>();
     protected Minecraft mc;
     public int updateCounter = 0;
     private String recordPlaying = "";
@@ -73,7 +73,7 @@ public class HudIngame extends Gui
     private boolean colorString = false;
     public float damageGuiPartialTime;
     float prevVignetteBrightness = 1.0f;
-    protected Font font;
+    protected FontRenderer fontRenderer;
     public int chatScroll = 0;
 
     public final HeldItemTooltipElement heldItemTooltipElement;
@@ -81,7 +81,7 @@ public class HudIngame extends Gui
     public HudIngame(Minecraft minecraft)
     {
         this.mc = minecraft;
-        this.font = mc.font;
+        this.fontRenderer = this.mc.font;
         this.heldItemTooltipElement = new HeldItemTooltipElement(mc);
     }
 
@@ -93,7 +93,6 @@ public class HudIngame extends Gui
         int width = mc.resolution.getScaledWidthScreenCoords();
         int height = mc.resolution.getScaledHeightScreenCoords();
         int sp = (int) ((mc.gameSettings.screenPadding.value * height) / 8);
-        Font font = mc.font;
         mc.worldRenderer.setupScaledResolution();
 
         GL11.glEnable(3042 /* GL_BLEND */);
@@ -435,12 +434,12 @@ public class HudIngame extends Gui
                     } else {
                         color = 0xFFFFFF;
                     }
-                    drawString(font, "Better than Adventure! ", tsp, tsp + lineHeight * line, color);
-                    drawString(font, Global.VERSION, tsp + font.getStringWidth("Better than Adventure! "), tsp + lineHeight * line++, 0xffffff);
+                    drawStringShadow(fontRenderer, "Better than Adventure! ", tsp, tsp + lineHeight * line, color);
+                    drawStringShadow(fontRenderer, Global.VERSION, FontHelper.getLastEndingX(), tsp + lineHeight * line++, 0xffffff);
                 }
                 if (mc.gameSettings.fpsInOverlay.value)
                 {
-                    drawString(font, mc.debugFPS, tsp, tsp + lineHeight * line++, 0xffffff);
+                    drawStringShadow(fontRenderer, mc.debugFPS, tsp, tsp + lineHeight * line++, 0xffffff);
                 }
                 if (compass)
                 {
@@ -448,24 +447,24 @@ public class HudIngame extends Gui
                     {
                         if (mc.gameSettings.overlayMode.value == 0)
                         {
-                            drawString(font, "x: " + floor10(mc.thePlayer.x) + " y: " + floor10(mc.thePlayer.y) + " z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
+                            drawStringShadow(fontRenderer, "x: " + floor10(mc.thePlayer.x) + " y: " + floor10(mc.thePlayer.y) + " z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
                         }
                         if (mc.gameSettings.overlayMode.value == 1)
                         {
-                            drawString(font, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xffffff);
-                            drawString(font, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0xffffff);
-                            drawString(font, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
+                            drawStringShadow(fontRenderer, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xffffff);
+                            drawStringShadow(fontRenderer, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0xffffff);
+                            drawStringShadow(fontRenderer, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
                         }
                         if (mc.gameSettings.overlayMode.value == 2)
                         {
-                            drawString(font, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xff8080);
-                            drawString(font, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0x80ff80);
-                            drawString(font, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0x8080ff);
+                            drawStringShadow(fontRenderer, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xff8080);
+                            drawStringShadow(fontRenderer, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0x80ff80);
+                            drawStringShadow(fontRenderer, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0x8080ff);
                         }
                     }
                     if (mc.gameSettings.overlayShowDirection.value)
                     {
-                        drawString(font, I18n.getInstance().translateKey(getFacingDirection(mc.thePlayer).getTranslationKey()), tsp, tsp + lineHeight * line++, 0xffffff);
+                        drawStringShadow(fontRenderer, I18n.getInstance().translateKey(getFacingDirection(mc.thePlayer).getTranslationKey()), tsp, tsp + lineHeight * line++, 0xffffff);
                     }
                 }
                 if (clock)
@@ -474,12 +473,12 @@ public class HudIngame extends Gui
                     {
                         if (mc.gameSettings.overlayMode.value == 0)
                         {
-                            this.drawString(font, String.format("%s %s %d", getTimeString(), I18n.getInstance().translateKey("unit.day"),mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
+                            this.drawStringShadow(fontRenderer, String.format("%s %s %d", getTimeString(), I18n.getInstance().translateKey("unit.day"),mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
                         }
                         if (mc.gameSettings.overlayMode.value > 0)
                         {
-                            this.drawString(font, getTimeString(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
-                            this.drawString(font, String.format("%s %d", I18n.getInstance().translateKey("unit.day"),mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
+                            this.drawStringShadow(fontRenderer, getTimeString(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
+                            this.drawStringShadow(fontRenderer, String.format("%s %d", I18n.getInstance().translateKey("unit.day"),mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
                         }
                     }
                 }
@@ -490,7 +489,7 @@ public class HudIngame extends Gui
                         Season season = mc.currentWorld.getSeasonManager().getCurrentSeason();
                         if (season != null)
                         {
-                            this.drawString(font, season.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0x80ffff : 0xffffff);
+                            this.drawStringShadow(fontRenderer, season.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0x80ffff : 0xffffff);
                         }
                     }
                     if (mc.gameSettings.overlayShowWeather.value)
@@ -498,7 +497,7 @@ public class HudIngame extends Gui
                         Weather weather = mc.currentWorld.getCurrentWeather();
                         if (weather != null && weather != mc.currentWorld.worldType.getDefaultWeather())
                         {
-                            this.drawString(font, stringtranslate.translateKey(weather.getNameLanguageKey()), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xff80ff : 0xffffff);
+                            this.drawStringShadow(fontRenderer, stringtranslate.translateKey(weather.getNameLanguageKey()), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xff80ff : 0xffffff);
                         }
                     }
 					if(mc.gameSettings.overlayShowBiome.value)
@@ -507,7 +506,7 @@ public class HudIngame extends Gui
 						int blockY = MathHelper.floor(mc.thePlayer.y);
 						int blockZ = MathHelper.floor(mc.thePlayer.z);
 						String key = mc.currentWorld.getBlockBiome(blockX, blockY, blockZ).translationKey;
-						drawString(font, stringtranslate.translateKey(key), tsp, tsp + lineHeight * line++, 0xffffff);
+						drawStringShadow(fontRenderer, stringtranslate.translateKey(key), tsp, tsp + lineHeight * line++, 0xffffff);
 					}
                 }
             }
@@ -535,7 +534,7 @@ public class HudIngame extends Gui
 
                         glDisable(GL_BLEND);
                         glDisable(GL_LIGHTING);
-                        font.drawStringWithShadow(String.valueOf((stack.getMaxDamage() - stack.getMetadata()) + 1), x + 20, y + 4, i1);
+                        drawStringShadow(this.fontRenderer, String.valueOf((stack.getMaxDamage() - stack.getMetadata()) + 1), x + 20, y + 4, i1);
                     }
                 }
             }
@@ -561,7 +560,7 @@ public class HudIngame extends Gui
                     
                     final int color = Color.HSBtoRGB(durability/3F, 1f, 1f);
                     int remainingDurability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) + 1;
-                    font.drawStringWithShadow("" + remainingDurability, x + 18, y + 4, color);
+                    drawStringShadow(this.fontRenderer, "" + remainingDurability, x + 18, y + 4, color);
                 }
                 else
                 {
@@ -580,7 +579,7 @@ public class HudIngame extends Gui
 
                     if (renderItem)
                     {
-                        font.drawStringWithShadow("" + itemCount, x + 18, y + 4, 0xffffff);
+                        drawStringShadow(this.fontRenderer, "" + itemCount, x + 18, y + 4, 0xffffff);
                     }
                 }
 
@@ -661,35 +660,35 @@ public class HudIngame extends Gui
 
     private final int debugLineHeight = 10;
 
-    private void drawDebugScreenLine(String string, boolean right, int line, int offset)
+    private void drawDebugScreenLine(final CharSequence string, final boolean right, final int line, final int offset)
     {
-        int width = font.getStringWidth(string);
+        int width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(string));
         int height = debugLineHeight;
         int x = right ? (int) ((mc.resolution.getScaledWidthScreenCoords() / DEBUG_SCALE) - width - 2) : 2;
         int y = 3 + line * debugLineHeight + offset;
 
         glDisable(GL_TEXTURE_2D);
         glColor4d(0.2, 0.2, 0.2, 0.6);
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator t = Tessellator.instance;
 
-        tessellator.startDrawingQuads();
-        tessellator.drawRectangle(x - 1, y - 1, width + 2, height);
-        tessellator.draw();
+        t.startDrawingQuads();
+        t.drawRectangle(x - 1, y - 1, width + 2, height);
+        t.draw();
 
         glEnable(GL_TEXTURE_2D);
 
 //		fontrenderer.drawStringWithShadow(string, x, y, 0xFFFFFF);
-        font.drawString(string, x, y, 0xFFFFFF);
+        drawStringNoShadow(this.fontRenderer, string, x, y, 0xFFFFFF);
     }
 
-    private void drawDebugScreenLine(String string)
+    private void drawDebugScreenLine(final CharSequence string)
     {
-        drawDebugScreenLine(string, false, debugLine++, debugOffset);
+        drawDebugScreenLine(string, false, this.debugLine++, this.debugOffset);
     }
 
-    private void drawDebugScreenLineRight(String string)
+    private void drawDebugScreenLineRight(final CharSequence string)
     {
-        drawDebugScreenLine(string, true, debugLineRight++, debugOffsetRight);
+        drawDebugScreenLine(string, true, this.debugLineRight++, this.debugOffsetRight);
     }
 
     private final List<String> playerListScoreStrings = new ArrayList<>();
@@ -722,9 +721,9 @@ public class HudIngame extends Gui
 
         for (Map.Entry<String, String> a1 : players.entrySet())
         {
-            longestNameWidth = java.lang.Math.max(font.getStringWidth(a1.getKey()), longestNameWidth);
+            longestNameWidth = Math.max(MathHelper.ceil(this.fontRenderer.stringWidthDouble(a1.getKey())), longestNameWidth);
 
-            longestScoreWidth = java.lang.Math.max(font.getStringWidth(a1.getValue()), longestScoreWidth);
+            longestScoreWidth = Math.max(MathHelper.ceil(this.fontRenderer.stringWidthDouble(a1.getValue())), longestScoreWidth);
             playerListScoreStrings.add(a1.getValue());
         }
 
@@ -768,11 +767,11 @@ public class HudIngame extends Gui
             int posX = listX + x * columnWidth + x * innerPadding + outerPadding;
             int posY = listY + y * lineHeight + y * innerPadding + outerPadding;
 
-            int scoreStringWidth = font.getStringWidth(a2.getValue());
+            int scoreStringWidth = MathHelper.ceil(fontRenderer.stringWidthDouble(a2.getValue()));
             drawRect(posX - 2, posY - 2, posX + columnWidth + 2, posY + 10, 0xffa5a5a5);
             drawRect(posX - 1, posY - 1, posX + columnWidth + 1, posY + 9, 0xA8080808);
-            font.drawStringWithShadow(a2.getKey(), posX, posY, 0xFFFFFF);
-            font.drawStringWithShadow(TextFormatting.YELLOW + a2.getValue(), posX + columnWidth - scoreStringWidth, posY, 0xFFFFFF);
+            drawStringShadow(this.fontRenderer,a2.getKey(), posX, posY, 0xFFFFFF);
+            drawStringShadow(this.fontRenderer,TextFormatting.YELLOW + a2.getValue(), posX + columnWidth - scoreStringWidth, posY, 0xFFFFFF);
             i++;
         }
     }
@@ -798,7 +797,7 @@ public class HudIngame extends Gui
                 {
                     k4 = Color.HSBtoRGB(f2 / 50F, 0.7F, 0.6F) & 0xffffff;
                 }
-                font.drawString(recordPlaying, -font.getStringWidth(recordPlaying) / 2, -4, k4 + (j3 << 24));
+                drawStringNoShadow(this.fontRenderer, recordPlaying, MathHelper.ceil(-fontRenderer.stringWidthDouble(recordPlaying) / 2), -4, k4 + (j3 << 24));
                 GL11.glDisable(3042 /* GL_BLEND */);
                 GL11.glPopMatrix();
             }
@@ -808,18 +807,18 @@ public class HudIngame extends Gui
     public void drawChat(int width, int height, int sp)
     {
         if (mc.gameSettings.chatVisibility.value == ChatVisibility.NEVER_SHOW) return;
-        int messagesToShow = 10;
+        int linesToShow = 10;
         boolean ignoreFadeout = false;
         if (mc.currentScreen instanceof ScreenChat)
         {
             int acceptableSize = height - 48 - 48;
-            messagesToShow = acceptableSize / 9;
+            linesToShow = acceptableSize / 9;
             ignoreFadeout = true;
         } else if (mc.gameSettings.chatVisibility.value == ChatVisibility.SHOW_WHEN_CHATTING) {
             return;
         }
 
-        if (chatScroll > chatMessageList.size() - messagesToShow) chatScroll = chatMessageList.size() - messagesToShow;
+        if (chatScroll > chatMessageList.size() - linesToShow) chatScroll = chatMessageList.size() - linesToShow;
         if (chatScroll < 0) chatScroll = 0;
 
         GL11.glEnable(GL_BLEND);
@@ -827,13 +826,15 @@ public class HudIngame extends Gui
         GL11.glDisable(GL_ALPHA_TEST);
         GL11.glPushMatrix();
         GL11.glTranslatef(0.0F, height - 48, 0.0F);
-        for (int i = chatScroll; i < chatMessageList.size() && i < chatScroll + messagesToShow; i++)
-        {
-            if (chatMessageList.get(i).updateCounter >= 190 && !ignoreFadeout)
+        int y = -12;
+        for (int i = 0; i < linesToShow; i++) {
+            if (this.chatScroll + i >= this.chatMessageList.size()) continue;
+            final ChatLine line = this.chatMessageList.get(this.chatScroll + i);
+            if (line.updateCounter >= 190 && !ignoreFadeout)
             {
                 continue;
             }
-            double fadeAmount = (double) chatMessageList.get(i).updateCounter / 200D;
+            double fadeAmount = (double) line.updateCounter / 200D;
             fadeAmount = 1.0D - fadeAmount;
             fadeAmount *= 10D;
             if (fadeAmount < 0.0D)
@@ -852,12 +853,13 @@ public class HudIngame extends Gui
             }
             if (alpha > 0)
             {
-                byte xPad = 2;
-                int y = -(i - chatScroll) * 9 - 12;
-                String s1 = chatMessageList.get(i).message;
-                drawRect(xPad, y - 1 - sp, xPad + 320, y + 8 - sp, alpha / 2 << 24);
+                final CharSequence message = line.message;
+                final byte xPad = 2;
+                final int h = MathHelper.ceil( this.fontRenderer.heightOfConstrainedChars(message, MAX_CHAT_WIDTH));
+                y -= (h + 2);
+                drawRect(xPad, y - sp - 1, xPad + MAX_CHAT_WIDTH, y + h - sp + 1, alpha / 2 << 24);
                 GL11.glEnable(GL_BLEND);
-                mc.font.drawStringWithShadow(s1, xPad, y - sp, 0xFFFFFF + (alpha << 24));
+                FontHelper.renderWidthConstrained(Tessellator.instance, message, xPad, y, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call(this.fontRenderer);
             }
         }
 
@@ -985,37 +987,12 @@ public class HudIngame extends Gui
         chatMessageList.clear();
     }
 
-    public void addChatMessage(String s)
+    public void addChatMessage(final CharSequence s)
     {
         LOGGER.info("[CHAT] {}", s);
-        int i;
-        TextFormatting activeFormatting = null;
-        while (mc.font.getStringWidth(s) > 320)
-        {
-            for (i = 1; i < s.length() && mc.font.getStringWidth(s.substring(0, i + 1)) <= 320; i++) {
-                char c = s.charAt(i - 1);
-                if (c == '§') {
-                    char code = s.charAt(i);
-                    for (TextFormatting formatting : TextFormatting.FORMATTINGS) {
-                        if (formatting.code == code) {
-                            activeFormatting = formatting;
-                            break;
-                        }
-                    }
-                }
-            }
-            addChatMessage(s.substring(0, i));
-            if (activeFormatting != null) {
-                s = "" + '§' + activeFormatting.code + s.substring(i);
-            } else {
-                s = s.substring(i);
-            }
-        }
-
-        chatMessageList.add(0, new ChatLine(s));
-        while (chatMessageList.size() > 100)
-        {
-            chatMessageList.remove(chatMessageList.size() - 1);
+        this.chatMessageList.add(0, new ChatLine(s));
+        while (this.chatMessageList.size() > 100) {
+            this.chatMessageList.remove(this.chatMessageList.size() - 1);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
index 5d31bc3be..309b28ca1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
@@ -5,7 +5,6 @@ import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
 import org.lwjgl.opengl.GL11;
@@ -223,7 +222,7 @@ public class HudIngameDoom
         }
 
         drawTexturedModalRect(x, y, u, v, 13, 13);
-        drawString(font, Integer.toString(number % 10), x + 4, y + 3, textColor);
+        drawStringShadow(fontRenderer, Integer.toString(number % 10), x + 4, y + 3, textColor);
     }
 
     private void drawArmor()
@@ -289,11 +288,11 @@ public class HudIngameDoom
         name = name.toUpperCase();
         if (selected)
         {
-            drawString(font, TextFormatting.get(stack.getDisplayColor()) + name, x, y, 0xFFFFFFFF);
+            drawStringShadow(fontRenderer, TextFormatting.get(stack.getDisplayColor()) + name, x, y, 0xFFFFFFFF);
         }
         else
         {
-            drawStringNoShadow(font, name, x, y, 0xFF404040);
+            drawStringNoShadow(fontRenderer, name, x, y, 0xFF404040);
         }
 
         int maxStackSize = stack.getMaxStackSize();
@@ -302,21 +301,21 @@ public class HudIngameDoom
         // Draw stack size
         if (stackSize < 10)
         {
-            drawString(font, Integer.toString(stackSize), x + 70, y, 0xFFFFFFA0);
+            drawStringShadow(fontRenderer, Integer.toString(stackSize), x + 70, y, 0xFFFFFFA0);
         }
         else
         {
-            drawString(font, Integer.toString(stackSize), x + 64, y, 0xFFFFFFA0);
+            drawStringShadow(fontRenderer, Integer.toString(stackSize), x + 64, y, 0xFFFFFFA0);
         }
 
         // Draw max stack size
         if (maxStackSize < 10)
         {
-            drawString(font, Integer.toString(maxStackSize), x + 88, y, 0xFFFFFFA0);
+            drawStringShadow(fontRenderer, Integer.toString(maxStackSize), x + 88, y, 0xFFFFFFA0);
         }
         else
         {
-            drawString(font, Integer.toString(maxStackSize), x + 82, y, 0xFFFFFFA0);
+            drawStringShadow(fontRenderer, Integer.toString(maxStackSize), x + 82, y, 0xFFFFFFA0);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java
index ae7c390f9..ca6913b97 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java
@@ -5,6 +5,8 @@ import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.gui.subtitles.SubtitleTracker;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.sound.SoundRepository;
 import org.lwjgl.opengl.GL11;
 
@@ -58,12 +60,12 @@ public class HubComponentSubtitles extends HudComponentMovable {
             if (entry.soundEvent == null) {
                 continue;
             }
-            int msgWidth = mc.font.getStringWidth(entry.soundEvent.getSubtitleTranslated());
+            int msgWidth = mc.font.stringWidth(entry.soundEvent.getSubtitleTranslated());
             if (msgWidth > maxMessageWidth) {
                 maxMessageWidth = msgWidth;
             }
         }
-        maxMessageWidth += mc.font.getStringWidth("<") + mc.font.getStringWidth(">");
+        maxMessageWidth += mc.font.stringWidth("<") + mc.font.stringWidth(">");
 
         GL11.glEnable(GL_BLEND);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
@@ -96,16 +98,18 @@ public class HubComponentSubtitles extends HudComponentMovable {
             {
                 byte xPad = 3;
                 int y2 = -i * 9 - 8;
-                String s1 = entry.soundEvent.getSubtitleTranslated();
-                gui.drawRect(xRight - maxMessageWidth - xPad * 2, yBottom + y2 - 1, xRight, yBottom + y2 + 8, alpha / 2 << 24);
-                GL11.glEnable(GL_BLEND);
-                mc.font.drawCenteredString(s1, xRight - (maxMessageWidth) / 2 - xPad, yBottom + y2, 0xFFFFFF + (alpha << 24));
-                if (mc.thePlayer != null) {
-                    double sin = Math.sin(entry.getRelativeAngle(mc.thePlayer) + Math.PI/2);
-                    if (sin > 0.7) {
-                        mc.font.drawString("<", xRight - maxMessageWidth - xPad, yBottom + y2, 0xFFFFFF + (alpha << 24));
-                    } else if (sin < -0.7) {
-                        mc.font.drawString(">", xRight - mc.font.getStringWidth(">") - xPad/2, yBottom + y2, 0xFFFFFF + (alpha << 24));
+                final String subtitle = entry.soundEvent.getSubtitleTranslated();
+                if (subtitle != null) {
+                    gui.drawRect(xRight - maxMessageWidth - xPad * 2, yBottom + y2 - 1, xRight, yBottom + y2 + 8, alpha / 2 << 24);
+                    GL11.glEnable(GL_BLEND);
+                    FontHelper.renderCentered(Tessellator.instance, subtitle, xRight - (maxMessageWidth) / 2 - xPad, yBottom + y2).setShadow().setColor(0xFFFFFF + (alpha << 24)).call(mc.font);
+                    if (mc.thePlayer != null) {
+                        final double sin = Math.sin(entry.getRelativeAngle(mc.thePlayer) + Math.PI/2);
+                        if (sin > 0.7) {
+                            FontHelper.render(Tessellator.instance, "<", xRight - maxMessageWidth - xPad, yBottom + y2).setColor(0xFFFFFF + (alpha << 24)).call(mc.font);
+                        } else if (sin < -0.7) {
+                            FontHelper.render(Tessellator.instance, ">", xRight - mc.font.stringWidth(">") - xPad/2, yBottom + y2).setColor(0xFFFFFF + (alpha << 24)).call(mc.font);
+                        }
                     }
                 }
             }
